{$APPTYPE CONSOLE}
program Service;

uses Windows, Registry, TlHelp32, SysUtils;

var
 Add_Reg, Del_reg, Run_Hidden,
 Term_Service, Not_Run, Run_once: boolean;

function RegisterServiceProcess(dwProcessId, dwType:DWORD): DWORD; stdcall; external 'kernel32.dll';

function GetProcessId(ExeName: string): integer;
var
 hSnap:THandle;
 Pe:TProcessEntry32;
 ProcId: integer;
 ProcExe: string;
begin
 pe.dwSize:=SizeOf(pe);
 hSnap:=CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
 if Process32First(hSnap, pe) then
 begin
   while Process32Next(hSnap,pe) do
   begin
    ProcExe:=pe.szExeFile;
    ProcId:=pe.th32processid;
    if UpperCase(procexe) <> UpperCase(ExeName) then Continue;
    Result:=ProcId;
    CloseHandle(hSnap);
    Exit;
   end;
 end;
 Result:=0;
 CloseHandle(hSnap)
end;

function GetProcessExe(var ExeName:string): integer;
var
 hSnap:THandle;
 pe:TProcessEntry32;
 ProcId:integer;
 ProcHandle:integer;
 ProcExe:string;
begin
 pe.dwSize:=SizeOf(pe);
 hSnap:=CreateToolhelp32SnapShot(TH32CS_SNAPPROCESS, 0);
 if Process32First(hSnap, pe) then
 begin
   while Process32Next(hSnap, pe) do
   begin
    Procexe:=pe.szExeFile;
    ProcId:=pe.th32processid;
    if UpperCase(ProcExe) <> UpperCase(ExeName) then Continue;
    ProcHandle:=OpenProcess(PROCESS_ALL_ACCESS, True, ProcId);
    result:=ProcHandle;
    CloseHandle(hSnap);
    Exit;
   end;
 end;
 Result:=0;
 CloseHandle(hSnap)
end;

procedure Help;
begin
 Writeln('RunService 1.0 for Windows95/98 by Anton Geleznyak (2:5000/106)');
 Writeln('---------------------------------------------------------------');
 Writeln('Syntax: Runserv <exename> [keys]');
 Writeln('Possible keys are:');
 WRiteln('/a - add to registry services startup.');
 Writeln('/o - add to registry services startup to run once.');
 Writeln('/h - run hidden.');
 Writeln('/r - remove from registry services startup.');
 Writeln('/t - terminate service.');
 Writeln('/n - do not run.');
 Writeln('/h - this help screen.');
 Writeln('');
end;

procedure Add_to_Registry(ExeName: string);
var
 Reg: TRegistry;
begin
 Reg:=Tregistry.Create;
 Reg.RootKey:=HKEY_LOCAL_MACHINE;
 if not Run_Once then
  Reg.OpenKey('\SOFTWARE\MICROSOFT\WINDOWS\CURRENTVERSION\RUNSERVICES\',True) else
  Reg.OpenKey('\SOFTWARE\MICROSOFT\WINDOWS\CURRENTVERSION\RUNSERVICESONCE\',true);
 Reg.WriteString(ExeName, ExeName);
 Reg.CloseKey;
 Reg.Free
end;

procedure Remove_From_Registry(ExeName: string);
var
 Reg: TRegistry;
begin
 Reg:=TRegistry.Create;
 Reg.RootKey:=HKEY_LOCAL_MACHINE;
 Reg.OpenKey('\SOFTWARE\MICROSOFT\WINDOWS\CURRENTVERSION\RUNSERVICES\', True);
 if Reg.ValueExists(ExeName) then
  Reg.DeleteValue(ExeName) else
  begin
   Writeln('ERROR: Service record not found in the registry.');
   Halt(253);
  end;
 Reg.CloseKey;
 Reg.Free
end;

procedure Execute(ExeName: string);
begin
 if Run_Hidden then
  WinExec(Pchar(ExeName), sw_Hide) else
  WinExec(Pchar(ExeName), sw_Show);
 RegisterServiceProcess(GetProcessId(ExeName), 1);
end;

procedure TerminateService(ExeName: string);
begin
 if GetProcessExe(ExeName) = 0 then
  begin
   Writeln('ERROR: Cannot terminate process that is not started yet.');
   Halt(254);
  end;
 TerminateProcess(GetProcessExe(ExeName), 0);
end;

var
 i: integer;
begin
 Add_Reg:=false;
 Del_Reg:=false;
 Run_Hidden:=false;
 Term_Service:=false;
 Not_Run:=false;
 Run_Once:=false;

 if (ParamCount=0) or (LowerCase(ParamStr(1))='/h') then
  begin
   Help;
   Halt(0);
  end;
 if ParamCount > 1 then
  begin
    for i:=2 to ParamCount do
    begin
     if LowerCase(Paramstr(i))='/a' then Add_Reg:=True;
     if LowerCase(Paramstr(i))='/h' then Run_Hidden:=True;
     if LowerCase(Paramstr(i))='/r' then Del_Reg:=True;
     if LowerCase(Paramstr(i))='/t' then Term_Service:=True;
     if LowerCase(Paramstr(i))='/n' then Not_Run:=True;
     if LowerCase(Paramstr(i))='/o' then Run_Once:=True;
    end;
  end;

 if not FileExists(Paramstr(1)) then
  begin
   Writeln('ERROR: Exefile not found');
   Halt(255);
  end;
  if Add_Reg or Run_Once then Add_To_Registry(Paramstr(1));
  if Del_Reg then Remove_From_Registry(Paramstr(1));
  if Term_Service then TerminateService(Paramstr(1));
  if not Not_Run then Execute(ParamStr(1));
  Halt(0);
end.
